## Problem (121. The best time to buy and sell stocks)

https://leetcode.com/problems/best-time-to-buy-and-sell-stock/description/

## Title description

```
Given an array, the i-th element of it is the price of a given stock on the i-th day.

If you are only allowed to complete one transaction at most (that is, buy and sell a stock once), design an algorithm to calculate the maximum profit you can make.

Note: You cannot sell stocks before buying them.



Example 1:

Input: [7,1,5,3,6,4]
Output: 5
Explanation: Buy on Day 2 (stock price = 1) and sell on Day 5 (stock price = 6). Maximum profit = 6-1 = 5.
Note that the profit cannot be 7-1 = 6, because the selling price needs to be greater than the buying price; at the same time, you cannot sell stocks before buying.
Example 2:

Input: [7,6,4,3,1]
Output: 0
Explanation: In this case, no transaction is completed, so the maximum profit is 0.
```

## Pre-knowledge

-[array](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)

## Company

-Ali
-Tencent
-Baidu
-Byte

- amazon
- bloomberg
- facebook
- microsoft
- uber

## Idea

Since we want to get the most profit, our strategy should be to buy at a low point and sell at a high point.

Since the topic has a limit on the number of transactions and can only be traded once, the essence of the problem is actually to find the maximum value of the difference between peaks and troughs.

If it is represented by a diagram, it is like this：

![](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlu6k05dqj30jg0c20tf.jpg)

## Analysis of key points

-This kind of problem can be easily solved as long as you draw the above picture in your mind (or somewhere else).

## Code

Language support: JS, C++, Java, Python

JS Code:

```js
/**
 * @param {number[]} prices
 * @return {number}
 */
var maxProfit = function (prices) {
	let min = prices[0];
	let profit = 0;
	// 7 1 5 3 6 4
	for (let i = 1; i < prices.length; i++) {
		if (prices[i] > prices[i - 1]) {
			profit = Math.max(profit, prices[i] - min);
		} else {
			min = Math.min(min, prices[i]);
		}
	}

	return profit;
};
```

C++ Code:

```c++
/**
* The input in the C++ test case on the system has [], so you need to add a judgment
*/
class Solution {
public:
int maxProfit(vector<int>& prices) {
if (prices. empty()) return 0;
auto min = prices[0];
auto profit = 0;
for (auto i = 1; i < prices. size(); ++i) {
if (prices[i] > prices[i -1]) {
profit = max(profit, prices[i] - min);
} else {
min = std::min(min, prices[i]);;
}
}
return profit;
}
};
```

Java Code:

```java
class Solution {
public int maxProfit(int[] prices) {
int minprice = Integer. MAX_VALUE;
int maxprofit = 0;
for (int price: prices) {
maxprofit = Math. max(maxprofit, price - minprice);
minprice = Math. min(price, minprice);
}
return maxprofit;
}
}
```

Python Code:

```python
class Solution:
def maxProfit(self, prices: 'List[int]') -> int:
if not prices: return 0

min_price = float('inf')
max_profit = 0

for price in prices:
if price < min_price:
min_price = price
elif max_profit < price - min_price:
max_profit = price - min_price
return max_profit
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

## Related topics

- [122.best-time-to-buy-and-sell-stock-ii](./122.best-time-to-buy-and-sell-stock-ii.md)
- [309.best-time-to-buy-and-sell-stock-with-cooldown](./309.best-time-to-buy-and-sell-stock-with-cooldown.md)

If you have any comments on this, please leave me a message. I will check the answers one by one when I have time. For more algorithm routines, you can visit my LeetCode problem solving warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.
You can also pay attention to my public account "Force Buckle Plus" to take you to chew off the hard bone of the algorithm.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
