## Problem (122. The best time to buy and sell stocks II)

https://leetcode.com/problems/best-time-to-buy-and-sell-stock-ii/description/

## Title description

```
Given an array, the i-th element of it is the price of a given stock on the i-th day.

Design an algorithm to calculate the maximum profit you can get. You can complete as many transactions as possible (buy and sell a stock multiple times).

Note: You cannot participate in multiple transactions at the same time (you must sell the previous shares before buying again).



Example 1:

Input: [7,1,5,3,6,4]
Output: 7
Explanation: Buy on the second day (stock price = 1) and sell on the third day (stock price = 5). This transaction can make a profit = 5-1 = 4.
Subsequently, buy on the 4th day (stock price = 3) and sell on the 5th day (stock price = 6). This transaction can make a profit = 6-3 = 3.
Example 2:

Input: [1,2,3,4,5]
Output: 4
Explanation: Buy on the first day (stock price = 1) and sell on the fifth day (stock price = 5). This transaction can make a profit = 5-1 = 4.
Note that you cannot buy stocks one after another on the first and second days, and then sell them later.
Because this is because you have participated in multiple transactions at the same time, you must sell the previous shares before buying again.
Example 3:

Input: [7,6,4,3,1]
Output: 0
Explanation: In this case, no transaction is completed, so the maximum profit is 0.


prompt：

1 <= prices. length <= 3 * 10 ^ 4
0 <= prices[i] <= 10 ^ 4

```

## Pre-knowledge

-[array](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)

## Company

-Ali
-Tencent
-Baidu
-Byte

- bloomberg

## Idea

Since we want to get the most profit, our strategy should be to buy at a low point and sell at a high point.

Since the topic has no limit on the number of transactions, we should not let go of the opportunity to make money as long as we can.

> As shown in the figure below, we only need to find the sum of the bold parts

If it is represented by a diagram, it is like this：

![122.best-time-to-buy-and-sell-stock-ii](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlu8sjjprj30ff0bv0te.jpg)

## Analysis of key points

-This kind of problem can be easily solved as long as you draw the above picture in your mind (or somewhere else).

## Code

Language support: JS, C++, Java

JS Code:

```js
/**
 * @param {number[]} prices
 * @return {number}
 */
var maxProfit = function (prices) {
	let profit = 0;

	for (let i = 1; i < prices.length; i++) {
		if (prices[i] > prices[i - 1]) {
			profit = profit + prices[i] - prices[i - 1];
		}
	}

	return profit;
};
```

C++ Code:

```c++
class Solution {
public:
int maxProfit(vector<int>& prices) {
int res = 0;
for(int i=1;i<prices. size();i++)
{
if(prices[i] > prices[i-1])
{
res += prices[i] - prices[i-1];
}
}
return res;
}
};
```

Java Code:

```java
class Solution {
public int maxProfit(int[] prices) {
int res = 0;
for(int i=1;i<prices. length;i++)
{
if(prices[i] > prices[i-1])
{
res += prices[i] - prices[i-1];
}
}
return res;
}
}
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

## Related topics

- [121.best-time-to-buy-and-sell-stock](./121.best-time-to-buy-and-sell-stock.md)
- [309.best-time-to-buy-and-sell-stock-with-cooldown](./309.best-time-to-buy-and-sell-stock-with-cooldown.md)

If you have any comments on this, please leave me a message. I will check the answers one by one when I have time. For more algorithm routines, you can visit my LeetCode problem solving warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.
You can also pay attention to my public account "Force Buckle Plus" to take you to chew off the hard bone of the algorithm.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
