## Problem (125. Verify palindrome string)

https://leetcode.com/problems/valid-palindrome/description/

## Title description

```
Given a string, verify whether it is a palindrome string. Only alphanumeric and numeric characters are considered, and the case of the letters can be ignored.

Description: In this question, we define an empty string as a valid palindrome string.

Example 1:

Enter: "A man, a plan, a canal: Panama"
Output: true
Example 2:

Enter: "race a car"
Output: false

```

## Pre-knowledge

-Palindrome
-Double pointer

## Company

-Ali
-Tencent
-Baidu
-Byte

- facebook
- microsoft
- uber
- zenefits

## Idea

This is a topic that examines palindromes, and it is the simplest form, that is, to determine whether a string is a palindrome.

In view of this problem, we can use the head and tail double pointers，

-If the elements of the two pointers are not the same, false is returned directly,
-If the elements of the two pointers are the same, we update the head and tail pointers at the same time, loop. Until the head and tail pointers meet.

The time complexity is O(n).

Take a palindrome string like "noon” for example, our judgment process is like this：

![125.valid-palindrome-1](https://tva1.sinaimg.cn/large/007S8ZIlly1ghltxv0l6lj30fp0883yo.jpg)

Take “abaa”, a string that is not a palindrome, for example, our judgment process is like this：

![125.valid-palindrome-2](https://tva1.sinaimg.cn/large/007S8ZIlly1ghltxzbhiqj30ff07y74k.jpg)

## Analysis of key points

-Double pointer

## Code

-Language support: JS, C++, Python

JavaScript Code:

```js
/*
 * @lc app=leetcode id=125 lang=javascript
 *
 * [125] Valid Palindrome
 */
// Only process English characters (the title ignores case, we converted all the previous ones into lowercase, so here we only judge lowercase) and numbers
function isValid(c) {
	const charCode = c.charCodeAt(0);
	const isDigit =
		charCode >= "0".charCodeAt(0) && charCode <= "9".charCodeAt(0);
	const isChar = charCode >= "a".charCodeAt(0) && charCode <= "z".charCodeAt(0);

	return isDigit || isChar;
}
/**
 * @param {string} s
 * @return {boolean}
 */
var isPalindrome = function (s) {
	s = s.toLowerCase();
	let left = 0;
	let right = s.length - 1;

	while (left < right) {
		if (!isValid(s[left])) {
			left++;
			continue;
		}
		if (!isValid(s[right])) {
			right--;
			continue;
		}

		if (s[left] === s[right]) {
			left++;
			right--;
		} else {
			break;
		}
	}

	return right <= left;
};
```

C++ Code:

```C++
class Solution {
public:
bool isPalindrome(string s) {
if (s. empty())
return true;
const char* s1 = s. c_str();
const char* e = s1 + s. length() - 1;
while (e > s1) {
if (! isalnum(*s1)) {++s1; continue;}
if (! isalnum(*e)) {--e; continue;}
if (tolower(*s1) ! = tolower(*e)) return false;
else {--e; ++s1;}
}
return true;
}
};
```

Python Code:

```python
class Solution:
def isPalindrome(self, s: str) -> bool:
left, right = 0, len(s) - 1
while left < right:
if not s[left]. isalnum():
left += 1
continue
if not s[right]. isalnum():
right -= 1
continue
if s[left]. lower() == s[right]. lower():
left += 1
right -= 1
else:
break
return right <= left

def isPalindrome2(self, s: str) -> bool:
"""
Use language features to solve
"""
s = ''. join(i for i in s if i. isalnum()). lower()
return s == s[::-1]
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

If you have any comments on this, please leave me a message. I will check the answers one by one when I have time. For more algorithm routines, you can visit my LeetCode problem solving warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.
You can also pay attention to my public account "Force Buckle Plus" to take you to chew off the hard bone of the algorithm.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
