## Problem (1260. Two-dimensional grid migration)

https://leetcode.com/problems/shift-2d-grid/description/

## Title description

```

Give you a two-dimensional grid with n rows and m columns and an integer K. You need to migrate the grid k times.

Each "migration" operation will trigger the following activities：

Elements located in grid[i][j] will be moved to grid[i][j+1].
Elements located in grid[i][m-1] will be moved to grid[i+1][0].
Elements located in grid[n-1][m-1] will be moved to grid[0][0].
Please return to the two-dimensional grid finally obtained after k migration operations.



Example 1：



Input: grid = [[1,2,3],[4,5,6],[7,8,9]], k = 1
output：[[9,1,2],[3,4,5],[6,7,8]]
Example 2：



Input: grid = [[3,8,1,9],[19,7,2,5],[4,6,11,10],[12,0,21,13]], k = 4
output：[[12,0,21,13],[3,8,1,9],[19,7,2,5],[4,6,11,10]]
Example 3：

Input: grid = [[1,2,3],[4,5,6],[7,8,9]], k = 9
output：[[1,2,3],[4,5,6],[7,8,9]]


prompt：

1 <= grid. length <= 50
1 <= grid[i]. length <= 50
-1000 <= grid[i][j] <= 1000
0 <= k <= 100


```

## Pre-knowledge

-[array](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)
-Mathematics

## Company

-Byte

## Simulation method

### Idea

We translate the topic directly, without any hack practice.

### Code

```python
from copy import deepcopy

class Solution:
def shiftGrid(self, grid: List[List[int]], k: int) -> List[List[int]]:
n = len(grid)
m = len(grid[0])
for _ in range(k):
old = deepcopy(grid)
for i in range(n):
for j in range(m):
if j == m - 1:
grid[(i + 1) % n][0] = old[i][j]
elif i == n - 1 and j == m - 1:
grid[0][0] = old[i][j]
else:
grid[i][j + 1] = old[i][j]
return grid
```

Since it is easy, the above approach is barely acceptable, so we will consider optimization.

## Mathematical Analysis

### Idea

If we look closely at the matrix, we will find that in fact, such matrix migration is regular. As shown in the figure：
![image](https://tva1.sinaimg.cn/large/007S8ZIlly1ghluajlvo1j30us0u0439.jpg)

Therefore, this problem has been transformed into our one-dimensional matrix transfer problem. LeetCode also has the original title [189. Rotating array](https://leetcode-cn.com/problems/rotate-array /), at the same time, I also wrote an article [Cyclic shift algorithm that liberal arts students can understand] (https://lucifer.ren/blog/2019/12/11/rotate-list /) To discuss this specifically, in the end we used the cubic rotation method. The relevant mathematical proofs are also written. They are very detailed and will not be repeated here.

LeetCode really likes to change the soup without changing the medicine.

### Code

Python code：

```python
#
# @lc app=leetcode.cn id=1260 lang=python3
#
#[1260] Two-dimensional grid migration
#

# @lc code=start


class Solution:
def shiftGrid(self, grid: List[List[int]], k: int) -> List[List[int]]:
n = len(grid)
m = len(grid[0])
# 2D to 1D
arr = [grid[i][j] for i in range(n) for j in range(m)]
# Take modulo, narrow the range of k, and avoid meaningless operations
k %= m * n
res = []
# End-to-end exchange method

def reverse(l, r):
while l < r:
t = arr[l]
arr[l] = arr[r]
arr[r] = t
l += 1
r -= 1
#Thrice rotate
reverse(0, m * n - k - 1)
reverse(m * n - k, m * n - 1)
reverse(0, m * n - 1)
# 1D to 2D
row = []
for i in range(m * n):
if i > 0 and i % m == 0:
res. append(row)
row = []
row. append(arr[i])
res. append(row)

return res

# @lc code=end

```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

## Related topics

- [189. Rotating array](https://leetcode-cn.com/problems/rotate-array /)

## Reference

-[Cyclic shift algorithm that liberal arts students can understand] (https://lucifer . ren/blog/2019/12/11/rotate-list/)

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
