# Problem (1332. Delete the palindrome sequence)

https://leetcode.com/problems/remove-palindromic-subsequences/

## Title description

```
Give you a string s, which consists only of the letters 'a' and 'b'. Each deletion operation can delete a palindrome sequence from S.

Returns the minimum number of deletions to delete all characters in a given string (the string is empty).

Definition of "sub-sequence": If a string can be obtained by deleting certain characters of the original string without changing the order of the original characters, then this string is a sub-sequence of the original string.

Definition of "palindrome": If a string reads backwards and forwards in the same way, then this string is a palindrome.



Example 1：

Input: s = "ababa"
Output: 1
Explanation: The string itself is a palindrome sequence and only needs to be deleted once.
Example 2：

Input: s = "abb"
Output: 2
Explanation: "abb"-> "bb"-> "".
Delete the palindrome sequence "a" first, and then delete "bb".
Example 3：

Input: s = "baabb"
Output: 2
Explanation: "baabb"-> "b"-> "".
First delete the palindromic sub-sequence "baab", and then delete "b".
Example 4：

Input: s=""
Output: 0


prompt：

0 <= s. length <= 1000
s contains only the letters 'a' and 'b'
Have you encountered this question in a real interview?
```

## Pre-knowledge

-Palindrome

## Company

-No

## Idea

This is another ”shaking clever" topic. Similar topics are [1297. maximum-number-of-occurrences-of-a-substrate] (https://github.com/azl397985856/leetcode/blob/77db8fa47c7ee0a14b320f7c2d22f7c61ae53c35/problems/1297.maximum-number-of-occurrences-of-a-substring.md )

Since there are only two characters a and B. In fact, the most number of eliminations is 2. This is because we can eliminate a sub-sequence each time, instead of eliminating a sub-string. In this way, we can eliminate all 1s first and then all 2s (the same is true for eliminating 2s first), so that it only takes two times to complete. Is it possible to do it 0 times or 1 time? Yes.

For example, in the case of one elimination given in the title, the example given in the title is “ababa”. We found that it is actually a palindrome string in itself, so it can be eliminated all at once. Then there is an idea：

-If s is a palindrome, then we need to eliminate it once
-Otherwise it takes two times
-Be sure to pay attention to special circumstances, for empty strings, we need 0 times

If you interpret a palindrome, you only need two pointers to force it. For specific ideas, please refer to [125. Verify palindrome string](./125.valid-palindrome.md)

## Analysis of key points

-Pay attention to reviewing the topic, and be sure to use the topic condition “only contains two characters a and b”, otherwise it will be easy to do and very troublesome.

## Code

Code support: Python3, Java

Python3 Code:

```python

class Solution:
def removePalindromeSub(self, s: str) -> int:
if s == '':
return 0
def isPalindrome(s):
l = 0
r = len(s) - 1
while l < r:
if s[l] ! = s[r]:
return False
l += 1
r -= 1
return True
return 1 if isPalindrome(s) else 2
```

If you think that judging palindrome is not the focus of this question, you can also simply achieve it.：

Python3 Code:

```python
class Solution:
def removePalindromeSub(self, s: str) -> int:
if s == '':
return 0
return 1 if s == s[::-1] else 2

```

Java Code：

```java
class Solution {
public int removePalindromeSub(String s) {
if ("". equals(s)) {
return 0;
}
if (s. equals(new StringBuilder(s). reverse(). toString())) {
return 1;
}
return 2;
}
}
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
