## Problem (167. Sum of two numbers II-enter an ordered array)

https://leetcode.com/problems/two-sum-ii-input-array-is-sorted/

## Title description

This is the second version of leetcode's number one topic'two sum`, with a simple difficulty.

```
Given an ordered array that has been arranged in ascending order, find two numbers so that their sum is equal to the target number.

The function should return these two index values index1 and index2, where index1 must be less than index2.

description:

The returned index values (index1 and index2) are not zero-based.
You can assume that each input only corresponds to a unique answer, and you cannot reuse the same elements.
example:

Input: numbers = [2, 7, 11, 15], Target = 9
Output: [1,2]
Explanation: The sum of 2 and 7 is equal to the target number 9. Therefore, index1= 1, index2= 2.

```

## Pre-knowledge

-Double pointer

## Company

-Ali
-Tencent
-Baidu
-Byte

- amazon

## Idea

Since the topic does not have a requirement for spatial complexity, just use a hashmap to store the numbers that have been accessed.

If there are requirements for the spatial complexity of the topic, since the array is ordered, only double pointers are required. A left pointer, a right pointer，
If the value of left + right is greater than target, the right is moved to the left, otherwise the left is moved to the right. See the python code below for the code.

> If the array is out of order, it needs to be sorted first (it can also be seen from here how important sorting is)

## Analysis of key points

-Since it is ordered, double pointers are better

## Code

-Language support: JS, C++, Java, Python

Javascript Code:

```js
/**
* @param {number[]} numbers
* @param {number} target
* @return {number[]}
*/
var twoSum = function (numbers, target) {
const visited={}; // Record the numbers that appear, the spatial complexity N

for (let index = 0; index < numbers. length; index++) {
const element = numbers[index];
if (visited[target - element] ! == void 0) {
return [visited[target - element], index + 1];
}
visited[element] = index + 1;
}
return [];
};
```

C++ Code:

```c++
class Solution {
public:
vector<int> twoSum(vector<int>& numbers, int target) {
int n = numbers. size();
int left = 0;
int right = n-1;
while(left <= right)
{
if(numbers[left] + numbers[right] == target)
{
return {left + 1, right + 1};
}
else if (numbers[left] + numbers[right] > target)
{
right--;
}
else
{
left++;
}
}
return {-1, -1};
}
};
```

Java Code:

```java
class Solution {
public int[] twoSum(int[] numbers, int target) {
int n = numbers. length;
int left = 0;
int right = n-1;
while(left <= right)
{
if(numbers[left] + numbers[right] == target)
{
return new int[]{left + 1, right + 1};
}
else if (numbers[left] + numbers[right] > target)
{
right--;
}
else
{
left++;
}
}

return new int[]{-1, -1};
}
}
```

Python Code:

```python
class Solution:
def twoSum(self, numbers: List[int], target: int) -> List[int]:
visited = {}
for index, number in enumerate(numbers):
if target - number in visited:
return [visited[target-number], index+1]
else:
visited[number] = index + 1

# Implementation of the dual pointer idea
class Solution:
def twoSum(self, numbers: List[int], target: int) -> List[int]:
left, right = 0, len(numbers) - 1
while left < right:
if numbers[left] + numbers[right] < target:
left += 1
if numbers[left] + numbers[right] > target:
right -= 1
if numbers[left] + numbers[right] == target:
return [left+1, right+1]
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . It is currently 30KG.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlu0wr0tsj30p00dwt9t.jpg)
