## Problem (169. Most elements)

https://leetcode.com/problems/majority-element/

## Title description

```
Given an array of size n, find most of the elements in it. Most elements refer to elements that appear more than nn/2次数 in the array.

You can assume that the array is non-empty, and that there are always most elements in a given array.



Example 1:

Input: [3,2,3]
Output: 3
Example 2:

Input: [2,2,1,1,1,2,2]
Output: 2

```

## Pre-knowledge

-Voting algorithm

## Company

-Ali
-Tencent
-Baidu
-Byte

- adobe
- zenefits

## Idea

This problem is also known as the Water King Problem. That is, let us find more than half of the numbers in the array.

It is intuitive to use extra space to record the number of occurrences of each element, and use a separate variable to record the element with the most current occurrences. But this approach has a high spatial complexity, is it possible to optimize it? The answer is to use a "voting algorithm".

The principle of the voting algorithm is to eliminate different elements continuously until there are no different elements, and the remaining elements are the elements we are looking for. Note that the key here is to eliminate different numbers.

The principle behind it is very simple, that is, in the worst case, every number in the non-majority is eliminated from the majority, then the rest is the majority. In other cases, it is obvious that the majority itself is the rest.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlu7i1c8tj30mz0cjwfk.jpg)

## Analysis of key points

-Voting algorithm

## Code

-Language support: JS, Python, CPP

Javascript Code:

```js
var majorityElement = function (nums) {
	let count = 1;
	let majority = nums[0];
	for (let i = 1; i < nums.length; i++) {
		if (count === 0) {
			majority = nums[i];
		}
		if (nums[i] === majority) {
			count++;
		} else {
			count--;
		}
	}
	return majority;
};
```

Python Code:

```python
class Solution:
def majorityElement(self, nums: List[int]) -> int:
count, majority = 1, nums[0]
for num in nums[1:]:
if count == 0:
majority = num
if num == majority:
count += 1
else:
count -= 1
return majority
```

CPP Code:

```cpp
class Solution {
public:
int majorityElement(vector<int>& nums) {
int ans = 0, cnt = 0;
for (int n : nums) {
if (ans == n) ++cnt;
else if (cnt > 0) --cnt;
else {
ans = n;
cnt = 1;
}
}
return ans;
}
};
```

**Complexity analysis**

-Time complexity:$O(N)$, where N is the length of the array
-Spatial complexity:$O(1)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
