## Problem (172. Zero after factorial)

https://leetcode.com/problems/factorial-trailing-zeroes/

## Title description

```
Given an integer n, return n! The number of zeros in the mantissa as a result.

Example 1:

Input: 3
Output: 0
Explanation: 3! = 6, there are no zeros in the mantissa.
Example 2:

Input: 5
Output: 1
Explanation: 5! = 120, there is 1 zero in the mantissa.
Description: The time complexity of your algorithm should be O (log n).

```

## Pre-knowledge

-[recursion](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)

## Company

-Ali
-Tencent
-Baidu

- bloomberg

## Idea

We need to solve how many zeros are at the end of the result of multiplying these n numbers. Since the problem requires the complexity of log, violent solution is not possible.

Through observation, we found that if we want the end of the result to be 0, it must be multiplied by 2 and 5 after decomposing the prime factor. At the same time, after factorization, it is found that the number of 5 is much smaller than 2.，
Therefore, we only need to solve how many 5s there are after decomposing the prime factor of these n numbers.

![172.factorial-trailing-zeroes-2](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlubdkzp7j30i10970t2.jpg)

As shown in the figure, if n is 30, then the result should be the number of red 5s in the figure, which is 7.

![172.factorial-trailing-zeroes-1](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlubf2c3fj30hr0b4aar.jpg)

Our result is not directly f(n) = n / 5, for example, if n is 30, there are two 5s in 25.
Similarly, if n is 150, there will be 7 such numbers. By observing, we find that the law'f(n) =n/5+n/5^2+n/5^3+n/5^4+n/5^5+. . `

![172.factorial-trailing-zeroes-3](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlubgxccqj30h3091t9i.jpg)

If you can find the above rules, it's up to you to implement this formula recursively or cyclically.

## Analysis of key points

-Number theory

## Code

-Language support: JS, Python, C++, Java

Javascript Code:

```js
/*
 * @lc app=leetcode id=172 lang=javascript
 *
 * [172] Factorial Trailing Zeroes
 */
/**
 * @param {number} n
 * @return {number}
 */
var trailingZeroes = function (n) {
	// tag: Number theory

	// if (n === 0) return n;

	// Recursion: f(n) = n/5 + f(n/5)
	// return Math. floor(n / 5) + trailingZeroes(Math. floor(n / 5));
	let count = 0;
	while (n >= 5) {
		count += Math.floor(n / 5);
		n = Math.floor(n / 5);
	}
	return count;
};
```

Python Code:

```python
class Solution:
def trailingZeroes(self, n: int) -> int:
count = 0
while n >= 5:
n = n // 5
count += n
return count


# Recursion
class Solution:
def trailingZeroes(self, n: int) -> int:
if n == 0: return 0
return n // 5 + self. trailingZeroes(n // 5)
```

C++ Code:

```c++
class Solution {
public:
int trailingZeroes(int n) {
int res = 0;
while(n >= 5)
{
n/=5;
res += n;
}
return res;
}
};
```

Java Code:

```js
class Solution {
public int trailingZeroes(int n) {
int res = 0;
while(n >= 5)
{
n/=5;
res += n;
}
return res;
}
}
```

**Complexity analysis**

-Time complexity:$O(logN)$
-Spatial complexity:$O(1)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
