## Problem (190. Reverse binary bits)

https://leetcode.com/problems/reverse-bits/

## Title description

```
Reverses the binary bits of a given 32-bit unsigned integer.



Example 1：

Input: 00000010100101000001111010011100
Output: 00111001011110000010100101000000
Explanation: The input binary string 00000010100101000001111010011100 represents an unsigned integer 43261596，
Therefore, 964176192 is returned, and its binary representation is 001110010111100000101000000.
Example 2：

Input: 1111111111111111111111111111101
Output: 101111111111111111111111111111111111111111111111111111111111111
Explanation: The input binary string 1111111111111111111111111101 represents an unsigned integer 4294967293，
Therefore, 3221225471 is returned, and its binary representation is 1011111111111111111111111111111111111111111111111111111111111111111


prompt：

Please note that in some languages (such as Java), there is no unsigned integer type. In this case, both input and output will be designated as signed integer types, and should not affect your implementation, because regardless of whether an integer is signed or unsigned, its internal binary representation is the same.
In Java, the compiler uses binary complement notation to represent signed integers. Therefore, in Example 2 above, the input represents a signed integer -3, and the output represents a signed integer -1073741825.


Advanced:
If this function is called multiple times, how will you optimize your algorithm?

```

## Pre-knowledge

-Double pointer

## Company

-Ali
-Tencent
-Baidu

- airbnb
- apple

## Idea

This question is given a 32-bit unsigned integer, which allows you to flip it bitwise, the first digit becomes the last digit, and the second digit becomes the penultimate digit. 。 。

Then the idea is `double pointer`

> This pointer can be quoted

-n gradually moves to the left from the high position, and res gradually moves to the right from the low position (0).
-Step by step judgment, if the bit is 1, then res + 1, if the bit is 0, then res + 0

- If all 32 bits are traversed, the traversal ends

## Analysis of key points

1. The result of bit operations that can be performed with any number and 1 depends on the characteristics of the last digit of the number to simplify operation and improve performance

eg :

-n&1=== 1, indicating that the last digit of n is 1
-n&1===0, indicating that the last digit of n is 0

2. For JS, the ES specification did not have unsigned shaping in many previous versions. If it is converted to unsigned, you can use a trick'n>>> 0`

3. Dual "pointer" model

4. bit operation

## Code

-Language support: JS, C++, Python

JavaScript Code：

```js
/**
 * @param {number} n - a positive integer
 * @return {number} - a positive integer
 */
var reverseBits = function (n) {
	let res = 0;
	for (let i = 0; i < 32; i++) {
		res = (res << 1) + (n & 1);
		n = n >>> 1;
	}

	return res >>> 0;
};
```

C++ Code：

```C++
class Solution {
public:
uint32_t reverseBits(uint32_t n) {
auto ret = 0;
for (auto i = 0; i < 32; ++i) {
ret = (ret << 1) + (n & 1);
n >>= 1;
}
return ret;
}
};
```

Python Code:

```python
class Solution:
# @param n, an integer
# @return an integer
def reverseBits(self, n):
result = 0
for i in range(32):
result = (result << 1) | (n & 1)
n >>= 1
return result
# or
class Solution:
def reverseBits(self, n: int) -> int:
ans = 0
for i in range(31, -1, -1):
ans |= ((n >> i) & 1) << (31 - i)
return ans
```

**Complexity analysis**

-Time complexity:$O(logN)$
-Spatial complexity:$O(1)$

## Expand

The same operation can be done without iteration：

1. Swap the 1 digits adjacent to each other
2. Pairwise adjacent 2 digits are swapped
3. Pairwise adjacent 4 digits are swapped
4. Pairwise adjacent 8-digit swaps
5. Pairwise adjacent 16-bit swaps

The C++ code is as follows：

```C++
class Solution {
public:
uint32_t reverseBits(uint32_t n) {
auto ret = ((n & 0xaaaaaaaa) >> 1) | ((n & 0x55555555) << 1);
ret = ((ret & 0xcccccccc) >> 2) | ((ret & 0x33333333) << 2);
ret = ((ret & 0xf0f0f0f0) >> 4) | ((ret & 0x0f0f0f0f) << 4);
ret = ((ret & 0xff00ff00) >> 8) | ((ret & 0x00ff00ff) << 8);
return ((ret & 0xffff0000) >> 16) | ((ret & 0x0000ffff) << 16);
}
};
```

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
