## Problem (191. The number of digits 1)

https://leetcode.com/problems/number-of-1-bits/

## Title description

```
Write a function whose input is an unsigned integer that returns the number of digits of ‘1’ in its binary expression (also known as Hamming weight).



Example 1：

Input: 0000000000000000000000000000001011
Output: 3
Explanation: In the input binary string 0000000000000000000000001011, there are three digits as '1'.
Example 2：

Input: 000000000000000000000000010000000
Output: 1
Explanation: In the input binary string 00000000000000000000010000000, there is a total of '1'.
Example 3：

Input: 1111111111111111111111111111101
Output: 31
Explanation: In the input binary string 1111111111111111111111111101, a total of 31 digits are '1'.


prompt：

Please note that in some languages (such as Java), there is no unsigned integer type. In this case, both input and output will be designated as signed integer types, and should not affect your implementation, because regardless of whether an integer is signed or unsigned, its internal binary representation is the same.
In Java, the compiler uses binary complement notation to represent signed integers. Therefore, in Example 3 above, the input represents a signed integer -3.


Advanced:
If this function is called multiple times, how will you optimize your algorithm?

```

## Pre-knowledge

-[Bit operation](https://github.com/azl397985856/leetcode/blob/master/thinkings/bit.md)

## Company

-Ali
-Tencent
-Baidu
-Byte

- apple
- microsoft

## Idea

The meaning of this title is: given an unsigned integer, return the number of 1s when it is expressed in binary notation.

With a trick here, it can be easily obtained. It is the principle that "n & (n-1)` can "eliminate" the last 1 of "n".

> Why can the last 1 be eliminated? It's actually relatively simple. Let's think about it for ourselves.

In this way, we can continue to "n= n & (n-1)" until n=== 0, which means that there is no 1.
At this time, `how many 1s we eliminated and turned into one 1 are gone, which shows how many 1s n has`.

## Analysis of key points

1. 'n & (n-1)' can `eliminate' the principle of the last 1 of n to simplify the operation

2. bit operation

## Code

Language support: JS, C++, Python

JavaScript Code:

```js
/*
* @lc app=leetcode id=191 lang=javascript
*
*/
/**
* @param {number} n - a positive integer
* @return {number}
*/
var hammingWeight = function (n) {
let count = 0;
while (n ! == 0) {
n = n & (n - 1);
count++;
}

return count;
};
```

C++ code:

```c++
class Solution {
public:
int hammingWeight(uint32_t v) {
auto count = 0;
while (v ! = 0) {
v &= (v - 1);
++count;
}
return count;
}
};
```

Python Code:

```python
class Solution(object):
def hammingWeight(self, n):
"""
:type n: int
:rtype: int
"""
count = 0
while n:
n &= n - 1
count += 1
return count
```

**Complexity analysis**

-Time complexity:$O(logN)$
-Spatial complexity:$O(N)$

## Extension

Bit operations can be used to achieve the purpose. For example, an 8-bit integer 21:

![number-of-1-bits](https://tva1.sinaimg.cn/large/007S8ZIlly1ghltyhhz7mj308007w0sx.jpg)

C++ Code：

```c++
const uint32_t ODD_BIT_MASK = 0xAAAAAAAA;
const uint32_t EVEN_BIT_MASK = 0x55555555;
const uint32_t ODD_2BIT_MASK = 0xCCCCCCCC;
const uint32_t EVEN_2BIT_MASK = 0x33333333;
const uint32_t ODD_4BIT_MASK = 0xF0F0F0F0;
const uint32_t EVEN_4BIT_MASK = 0x0F0F0F0F;
const uint32_t ODD_8BIT_MASK = 0xFF00FF00;
const uint32_t EVEN_8BIT_MASK = 0x00FF00FF;
const uint32_t ODD_16BIT_MASK = 0xFFFF0000;
const uint32_t EVEN_16BIT_MASK = 0x0000FFFF;

class Solution {
public:

int hammingWeight(uint32_t v) {
v = (v & EVEN_BIT_MASK) + ((v & ODD_BIT_MASK) >> 1);
v = (v & EVEN_2BIT_MASK) + ((v & ODD_2BIT_MASK) >> 2);
v = (v & EVEN_4BIT_MASK) + ((v & ODD_4BIT_MASK) >> 4);
v = (v & EVEN_8BIT_MASK) + ((v & ODD_8BIT_MASK) >> 8);
return (v & EVEN_16BIT_MASK) + ((v & ODD_16BIT_MASK) >> 16);
}
};
```

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
