## Problem (20. Valid brackets)

https://leetcode.com/problems/valid-parentheses/description

## Title description

```
A given one includes only '('，')'，'{'，'}'，'['，']' The string to determine whether the string is valid.

Valid strings need to be satisfied：

The opening bracket must be closed with the same type of closing bracket.
The opening brackets must be closed in the correct order.
Note that an empty string can be considered a valid string.

Example 1:

Enter: "()"
Output: true
Example 2:

Enter: "()[]{}"
Output: true
Example 3:

Enter: "(]"
Output: false
Example 4:

Enter: "([)]"
Output: false
Example 5:

Input: "{[]}"
Output: true

```

## Pre-knowledge

-[Stack](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)

## Company

-Ali
-Baidu
-Tencent
-Byte

- airbnb
- amazon
- bloomberg
- facebook
- google
- microsoft
- twitter
- zenefits

## Stack

### Idea

Regarding the idea of this question, Deng Junhui spoke very well. Students who have not seen it can take a look at it. [Video address] (http://www.xuetangx.com/courses/course-v1:TsinghuaX +30240184+sp/courseware/ad1a23c053df4501a3facd66ef6ccfa9/8d6f450e7f7a445098ae1d507fda80f6/).

Use the stack to traverse the input string

If the current character is a left half-square bracket, press it into the stack

If you encounter the right half of the brackets, categorize and discuss：

1. If the stack is not empty and it is the corresponding left half bracket, then take out the top element of the stack and continue the loop.

2. If the stack is empty at this time, return false directly

3. If it is not the corresponding left half bracket, return false on the contrary

![20.validParentheses](https://tva1.sinaimg.cn/large/007S8ZIlly1ghltyb2lpvg30qo0f0n2n.gif)

(Picture from: https://github.com/MisterBooo/LeetCodeAnimation )

It is worth noting that if the topic requires only one type of bracket, then we can actually use a more concise and memory-saving method-counters to solve it, without the need to use stacks. The reason why multiple brackets cannot be used to do it in the 空间 O(1) 空间 space is because use cases like this will not be able to handle "([)]".

### Analysis of key points

1. Basic characteristics and operation of the stack
2. You can use arrays to simulate stacks

For example, in: push out: pop is the stack. In: push out shift is the queue. However, the queue implemented by this algorithm has a relatively high time complexity when deleting elements in the header. For details, you can refer to [double-ended queue deque] (https://zh.wikipedia.org/wiki/%E5%8F%8C%E7%AB%AF%E9%98%9F%E5%88%97 ).

### Code

Code support: JS, Python

Javascript Code:

```js
/**
* @param {string} s
* @return {boolean}
*/
var isValid = function (s) {
let valid = true;
const stack = [];
const mapper = {
"{": "}",
"[": "]",
"(": ")",
};

for (let i in s) {
const v = s[i];
if (["(", "[", "{"]. indexOf(v) > -1) {
stack. push(v);
} else {
const peak = stack. pop();
if (v ! == mapper[peak]) {
return false;
}
}
}

if (stack. length > 0) return false;

return valid;
};
```

Python Code:

```py
class Solution:
def isValid(self,s):
stack = []
map = {
"{":"}",
"[":"]",
"(":")"
}
for x in s:
if x in map:
stack. append(map[x])
else:
if len(stack)! =0:
top_element = stack. pop()
if x ! = top_element:
return False
else:
continue
else:
return False
return len(stack) == 0
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(N)$

##O(1) space

### Idea

The basic idea is to modify the parameters and use the parameters as our stack. As we continue to traverse, s slowly becomes a stack.

Therefore, languages with immutable strings such as Python, Java, JS, etc. cannot use this method to reach $O(1)$.

Specific reference: [No stack O(1) space complexity O(n) time complexity solution in C++](<https://leetcode.com/problems/valid-parentheses/discuss/9478/No-stack-O (1)-space-complexity-O(n)-time-complexity-solution-in-C++/244061>)

### Code

Code support: C++

C++:

```c++
class Solution {
public:
bool isValid(string s) {
int top = -1;
for(int i =0;i<s. length();++i){
if(top<0 || ! isMatch(s[top], s[i])){
++top;
s[top] = s[i];
}else{
--top;
}
}
return top == -1;
}
bool isMatch(char c1, char c2){
if(c1 == '(' && c2 == ')') return true;
if(c1 == '[' && c2 == ']') return true;
if(c1 == '{' && c2 == '}') return true;
return false;
}
};
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

## Regular matching

### Idea

We continue to eliminate '[]' ， '()', '{}' ， Finally, it is enough to judge whether the rest is an empty string, just like happy Xiaoxiaole.

### Code

Code support: Python, JavaScript

Python:

```py
class Solution:
def isValid(self, s):

while '[]' in s or '()' in s or '{}' in s:
s = s. replace('[]',''). replace('()',''). replace('{}','')
return not len(s)
```

JavaScript:

```js
var isValid = function (s) {
	while (s.includes("[]") || s.includes("()") || s.includes("{}")) {
		s = s.replace("[]", "").replace("()", "").replace("{}", "");
	}
	s = s.replace("[]", "").replace("()", "").replace("{}", "");
	return s.length === 0;
};
```

**Complexity analysis**

-Time complexity: depends on the implementation of the regularization engine
-Spatial complexity: depends on the implementation of the regularization engine

## Related topics

- [32. Longest valid bracket](./32.longest-valid-parentheses.md)

## Extension

-If you are asked to check whether the XML tag is closed, how to check, and further, if you want to implement a simple XML parser, how should you implement it?
-In fact, this kind of problem can be further extended. We can parse tag syntax like HTML, such as `<p></p><body></body>`

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
