## Problem (203. Remove linked list elements)

https://leetcode.com/problems/remove-linked-list-elements/

## Title description

```
Delete all nodes in the linked list that are equal to the given value val.

example:

input: 1->2->6->3->4->5->6, val = 6
output: 1->2->3->4->5

```

## Pre-knowledge

-[Linked list](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)

## Company

-Ali
-Tencent
-Baidu
-Byte

## Idea

I won't say much about the topic of the basic operation of a linked list.

Although the topic is relatively simple, the frequency of actual interviews is not low, so everyone must be able to write bug-free code.

90% of the bugs in the linked list title appear in：

1. Processing of head and tail nodes
2. Pointer circular reference causes an endless loop

Therefore, everyone should maintain 100% vigilance on these two issues.

## Analysis of key points

-Basic operation of linked list (delete specified node)
-Virtual node dummy simplifies operation

> In fact, the dummy node is set up to handle special locations (head nodes). This question is what if the head node is a given node that needs to be deleted?
> In order to ensure the consistency of code logic, that is, there is no need to customize the logic for the head node, the virtual node is used.

-If two consecutive nodes are the nodes to be deleted, this situation can easily be ignored.
eg:

```js
// Update current only if the next node is not the node to be deleted
if (! next || next. val ! == val) {
current = next;
}
```

## Code

-Language support: JS, Python

Javascript Code:

```js
/**
* @param {ListNode} head
* @param {number} val
* @return {ListNode}
*/
var removeElements = function (head, val) {
const dummy = {
next: head,
};
let current = dummy;

while (current && current. next) {
let next = current. next;
if (next. val === val) {
current. next = next. next;
next = next. next;
}

if (! next || next. val ! == val) {
current = next;
}
}

return dummy. next;
};
```

Python Code:

```python
# Definition for singly-linked list.
# class ListNode:
# def __init__(self, x):
# self. val = x
# self. next = None

class Solution:
def removeElements(self, head: ListNode, val: int) -> ListNode:
prev = ListNode(0)
prev. next = head
cur = prev
while cur. next:
if cur. next. val == val:
cur. next = cur. next. next
else:
cur = cur. next
return prev. next
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
