## Problem (21. Merge two ordered linked lists)

https://leetcode.com/problems/merge-two-sorted-lists

## Title description

```
Merge two ascending linked lists into a new ascending linked list and return. The new linked list is composed by splicing all the nodes of the given two linked lists.

example：

input：1->2->4, 1->3->4
output：1->1->2->3->4->4

```

## Pre-knowledge

-[recursion](https://github.com/azl397985856/leetcode/blob/master/thinkings/dynamic-programming.md) -[Linked list](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)

## Company

-Ali
-Byte
-Tencent

- amazon
- apple
- linkedin
- microsoft

## Company

-Ali, Byte, Tencent

## Idea

This question can be solved using recursion. Merge the smaller of the two linked list heads with the remaining elements, and return the sorted linked list heads, and terminate the recursion when one of the two linked lists is empty.

## Key points

-Master the linked list data structure
-Consider the boundary situation

## Code

-Language support: CPP, JS

CPP Code:

```cpp
class Solution {
public:
ListNode* mergeTwoLists(ListNode* l1, ListNode* l2) {
if (l1 == nullptr) {
return l2;
} else if (l2 == nullptr) {
return l1;
} else if (l1->val < l2->val) {
l1->next = mergeTwoLists(l1->next, l2);
return l1;
} else {
l2->next = mergeTwoLists(l1, l2->next);
return l2;
}
}
};
```

JS Code:

```js
/**
 * Definition for singly-linked list.
 * function ListNode(val) {
 * this. val = val;
 * this. next = null;
 * }
 */
/**
 * @param {ListNode} l1
 * @param {ListNode} l2
 * @return {ListNode}
 */
const mergeTwoLists = function (l1, l2) {
	if (l1 === null) {
		return l2;
	}
	if (l2 === null) {
		return l1;
	}
	if (l1.val < l2.val) {
		l1.next = mergeTwoLists(l1.next, l2);
		return l1;
	} else {
		l2.next = mergeTwoLists(l1, l2.next);
		return l2;
	}
};
```

**Complexity analysis**

M and N are the lengths of the two linked lists l1 and l2

-Time complexity:$O(M+N)$
-Spatial complexity:$O(M+N)$

## Extension

-Can you solve it iteratively?

The iterated CPP code is as follows：

```cpp
class Solution {
public:
ListNode* mergeTwoLists(ListNode* a, ListNode* b) {
ListNode head, *tail = &head;
while (a && b) {
if (a->val <= b->val) {
tail->next = a;
a = a->next;
} else {
tail->next = b;
b = b->next;
}
tail = tail->next;
}
tail->next = a ? a : b;
return head. next;
}
};
```

The iterated JS code is as follows：

```js
var mergeTwoLists = function (l1, l2) {
const prehead = new ListNode(-1);

let prev = prehead;
while (l1 ! = null && l2 ! = null) {
if (l1. val <= l2. val) {
prev. next = l1;
l1 = l1. next;
} else {
prev. next = l2;
l2 = l2. next;
}
prev = prev. next;
}
prev. next = l1 === null ? l2 : l1;

return prehead. next;
};
```

If you have any comments on this, please leave me a message. I will check the answers one by one when I have time. For more algorithm routines, you can visit my LeetCode problem solving warehouse:https://github.com/azl397985856/leetcode . It is currently 40K stars.
You can also pay attention to my public account "Force Buckle Plus" to take you to chew off the hard bone of the algorithm.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
