## Problem (219. Presence of duplicate elements II)

https://leetcode-cn.com/problems/contains-duplicate-ii/

## Title description

```
Given an array of integers and an integer k, it is determined whether there are two different indexes i and j in the array, such that nums [i] = nums [j], and the absolute value of the difference between i and j is at most K.



Example 1:

Input: nums = [1,2,3,1], k = 3
Output: true
Example 2:

Input: nums = [1,0,1,1], k = 1
Output: true
Example 3:

Input: nums = [1,2,3,1,2,3], k = 2
Output: false

```

## Pre-knowledge

- hashmap

## Company

-Ali
-Tencent
-Baidu
-Byte

## Idea

Use a hashmap to store the numbers that have been accessed. Check whether there is this element in the hashmap every time you visit. If so, take out the index for comparison, whether the conditions are met (the distance is not greater than k), and return true if satisfied.

It can be seen that this question is an advanced version of the two-digit sum. You can combine these two questions to understand~

## Company

- airbnb
- palantir

## Analysis of key points

-Space for time

## Code

-Language support: JS, Python, C++, Java

Javascript Code:

```js
/**
* @param {number[]} nums
* @param {number} k
* @return {boolean}
*/
var containsNearbyDuplicate = function (nums, k) {
const visited = {};
for (let i = 0; i < nums. length; i++) {
const num = nums[i];
if (visited[num] ! == undefined && i - visited[num] <= k) {
return true;
}
visited[num] = i;
}
return false;
};
```

Python Code:

```python
class Solution:
def containsNearbyDuplicate(self, nums: List[int], k: int) -> bool:
d = {}
for index, num in enumerate(nums):
if num in d and index - d[num] <= k:
return True
d[num] = index
return False
```

C++ Code：

```C++
class Solution {
public:
bool containsNearbyDuplicate(vector<int>& nums, int k) {
auto m = unordered_map<int, int>();
for (int i = 0; i < nums. size(); ++i) {
auto iter = m. find(nums[i]);
if (iter ! = m. end()) {
if (i - m[nums[i]] <= k) {
return true;
}
}
m[nums[i]] = i;
}
return false;
}
};
```

Java Code:

```java
class Solution {
public boolean containsNearbyDuplicate(int[] nums, int k) {
Map<Integer, Integer> map = new HashMap<>();
for(int i=0;i<nums. length;i++)
{
if(map. get(nums[i]) ! = null && (i-map. get(nums[i])) <= k)
{
return true;
}
map. put(nums[i], i);
}
return false;
}
}
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(N)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . It is currently 40K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
