## Problem (226. Flip binary tree)

https://leetcode.com/problems/invert-binary-tree/

## Title description

```
Flip a binary tree.

example：

input：

4
/ \
2 7
/ \ / \
1 3 6 9
output：

4
/ \
7 2
/ \ / \
9 6 3 1
Remarks:
This question is inspired by Max Howell's original question ：

Google: 90% of our engineers use the software you wrote (Homebrew), but you can't write the flipped binary tree question on the whiteboard during the interview. This is too bad.

```

## Pre-knowledge

-[recursion](https://github.com/azl397985856/leetcode/blob/master/thinkings/dynamic-programming.md)

## Company

-Ali
-Tencent
-Baidu
-Byte

## Idea

This is a classic interview question. It is not difficult. You can use it to practice recursion and iteration.

algorithm：

Traverse the tree (traverse whatever you want), and then exchange positions between the left and right subtrees.

## Analysis of key points

-Recursively simplify operations
-If the tree is very high, it is recommended to use a stack instead of recursion
-This question has no requirements for order, so the queue array operations are all the same, without any difference.

## Code

-Language support: JS, Python, C++

Javascript Code:

```js
/**
 * Definition for a binary tree node.
 * function TreeNode(val) {
 * this. val = val;
 * this. left = this. right = null;
 * }
 */
/**
 * @param {TreeNode} root
 * @return {TreeNode}
 */
var invertTree = function (root) {
	if (!root) return root;
	// Recursion
	// const left = root. left;
	// const right = root. right;
	// root. right = invertTree(left);
	// root. left = invertTree(right);
	// We use stack to simulate recursion
	// In essence, recursion makes use of the execution stack, and the execution stack is also a kind of stack
	//In fact, it is the same to use queues here, because the order is not important here

	const stack = [root];
	let current = null;
	while ((current = stack.shift())) {
		const left = current.left;
		const right = current.right;
		current.right = left;
		current.left = right;
		if (left) {
			stack.push(left);
		}
		if (right) {
			stack.push(right);
		}
	}
	return root;
};
```

Python Code:

```python
# Definition for a binary tree node.
# class TreeNode:
# def __init__(self, x):
# self. val = x
# self. left = None
# self. right = None

class Solution:
def invertTree(self, root: TreeNode) -> TreeNode:
if not root:
return None
stack = [root]
while stack:
node = stack. pop(0)
node. left, node. right = node. right, node. left
if node. left:
stack. append(node. left)
if node. right:
stack. append(node. right)
return root
```

C++ Code：

```C++
/**
* Definition for a binary tree node.
* struct TreeNode {
* int val;
* TreeNode *left;
* TreeNode *right;
* TreeNode(int x) : val(x), left(NULL), right(NULL) {}
* };
*/
class Solution {
public:
TreeNode* invertTree(TreeNode* root) {
if (root == NULL) return root;
auto q = queue<TreeNode*>();
q. push(root);
while (! q. empty()) {
auto n = q. front(); q. pop();
swap(n->left, n->right);
if (n->left ! = nullptr) {
q. push(n->left);
}
if (n->right ! = nullptr) {
q. push(n->right);
}
}
return root;
}
};
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(N)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
