## Problem (26. Delete duplicates in the sorted array)

https://leetcode.com/problems/remove-duplicates-from-sorted-array/description/

## Title description

Given a sorted array, you need to delete duplicate elements in place, so that each element only appears once, and return the new length of the array after removal.

Do not use extra array space, you must modify the input array in place and complete it under the condition of using O(1) extra space.

Example 1:

Given array nums = [1,1,2],

The function should return the new length 2, and the first two elements of the original array nums are modified to 1,2.

You don't need to consider the elements in the array that exceed the new length.
Example 2:

Given nums = [0,0,1,1,1,2,2,3,3,4],

The function should return the new length 5, and the first five elements of the original array nums are modified to 0, 1, 2, 3, 4。

You don't need to consider the elements in the array that exceed the new length.

description:

Why is the returned value an integer, but the output answer is an array?

Please note that the input array is passed by "reference", which means that modifying the input array in the function is visible to the caller.

You can imagine the internal operation as follows:

```c
// nums is passed by “reference”. In other words, do not make any copies of the arguments
int len = removeDuplicates(nums);

// Modifying the input array in the function is visible to the caller.
// According to the length returned by your function, it will print out all the elements in the array within that length range.
for (int i = 0; i < len; i++) {
print(nums[i]);
}
```

## Pre-knowledge

-[array](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)
-Double pointer

## Company

-Ali
-Tencent
-Baidu
-Byte

- bloomberg
- facebook
- microsoft

## Idea

Use the speed pointer to record the traversed coordinates.

-At the beginning, both pointers point to the first number

-If the two pointers refer to the same number, take the pointer one step forward

-If it is different, both pointers take a step forward

-When the fast pointer walks through the entire array, the current coordinates of the slow pointer plus 1 are the number of different numbers in the array.

![26.remove-duplicates-from-sorted-array](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlucxqaoyg30qg0esju1.gif)

(Picture from: https://github.com/MisterBooo/LeetCodeAnimation )

In fact, this is the speed pointer in the double pointer. Here, a fast pointer is a read pointer, and a slow pointer is a write pointer. \*\*From the perspective of reading and writing pointers, I think it is more in line with the essence.

## Analysis of key points

-Double pointer

If this question does not require the time complexity of O(n) and the space complexity of O(1), it will be very simple.
But this question is required, and the idea of this kind of question is generally to use double pointers.

-If the data is out of order, this method cannot be used. From here, it can also be seen that the basis and importance of sorting in the algorithm.

-Pay attention to the boundary conditions when nums is empty.

## Code

-Language support: JS, Python, C++

Javascript Code:

```js
/**
* @param {number[]} nums
* @return {number}
*/
var removeDuplicates = function (nums) {
const size = nums. length;
if (size == 0) return 0;
let slowP = 0;
for (let fastP = 0; fastP < size; fastP++) {
if (nums[fastP] ! == nums[slowP]) {
slowP++;
nums[slowP] = nums[fastP];
}
}
return slowP + 1;
};
```

Python Code:

```python
class Solution:
def removeDuplicates(self, nums: List[int]) -> int:
if nums:
slow = 0
for fast in range(1, len(nums)):
if nums[fast] ! = nums[slow]:
slow += 1
nums[slow] = nums[fast]
return slow + 1
else:
return 0
```

C++ Code:

```cpp
class Solution {
public:
int removeDuplicates(vector<int>& nums) {
if(nums. empty()) return 0;
int fast,slow;
fast=slow=0;
while(fast! =nums. size()){
if(nums[fast]==nums[slow]) fast++;
else {
slow++;
nums[slow]=nums[fast];
fast++;
}
}
return slow+1;
}
};
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(1)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlucyn5dcj30p00dwt9t.jpg)
