## Problem (263. Ugly number)

https://leetcode.com/problems/ugly-number/

## Title description

```
Write a program to determine whether a given number is an ugly number.

Ugly numbers are positive integers that contain only prime factors 2, 3, and 5.

Example 1:

Input: 6
Output: true
Explanation: 6 = 2 × 3
Example 2:

Input: 8
Output: true
Explanation: 8 = 2 × 2 × 2
Example 3:

Input: 14
Output: false
Explanation: 14 is not an ugly number because it contains another prime factor 7.
description：

1 is the ugly number.
The input will not exceed the range of 32−bit signed integers: [-231, 231-1].

```

## Pre-knowledge

-Mathematics
-Factorization

## Company

-Ali
-Tencent
-Baidu
-Byte

## Idea

The title requires that a number be given to determine whether it is an ”ugly number". An ugly number refers to a positive integer that contains only a prime factor of 2,3,5.

![263.ugly-number](https://tva1.sinaimg.cn/large/007S8ZIlly1ghltxf68kej30hh09fdgd.jpg)

By definition, we divide a given number by 2, 3, and 5 (the order does not matter) until it cannot be divisible.
If you get 1, it means that all factors are 2 or 3 or 5. If it is not 1, it is not an ugly number.

It's as if we judge whether a number is a power of n (n is a positive integer greater than 1), we just need
Divide by n continuously until it cannot be divisible. If you get 1, then it is a power of N. The difference in this question is
It is no longer a power of a certain number, but three numbers (2, 3, 5), but the idea of solving the problem is still the same.

Conversion to code can be：

```js
while (num % 2 === 0) num = num / 2;
while (num % 3 === 0) num = num / 3;
while (num % 5 === 0) num = num / 5;

return num === 1;
```

> The code I give below is implemented recursively, just to show you different writing methods.

## Key points

-Number theory
-Factorization

## Code

-Language support: JS, C++, Java, Python

Javascript Code:

```js
/*
 * @lc app=leetcode id=263 lang=javascript
 *
 * [263] Ugly Number
 */
/**
 * @param {number} num
 * @return {boolean}
 */
var isUgly = function (num) {
	// TAG: Number Theory
	if (num <= 0) return false;
	if (num === 1) return true;

	const list = [2, 3, 5];

	if (list.includes(num)) return true;

	for (let i of list) {
		if (num % i === 0) return isUgly(Math.floor(num / i));
	}
	return false;
};
```

**Complexity analysis**

-Time complexity:$O(logN)$
-Spatial complexity:$O(logN)$

C++ Code:

```c++
class Solution {
public:
bool isUgly(int num) {
int ugly[] = {2,3,5};
for(int u : ugly)
{
while(num%u==0 && num%u < num)
{
num/=u;
}
}
return num == 1;
}
};
```

Java Code:

```java
class Solution {
public boolean isUgly(int num) {
int [] ugly = {2,3,5};
for(int u : ugly)
{
while(num%u==0 && num%u < num)
{
num/=u;
}
}
return num == 1;
}
}
```

Python Code:

```python
#Non-recursive writing
class Solution:
def isUgly(self, num: int) -> bool:
if num <= 0:
return False
for i in (2, 3, 5):
while num % i == 0:
num /= i
return num == 1
```

**Complexity analysis**

-Time complexity:$O(logN)$
-Spatial complexity:$O(1)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
