## Problem (371. The sum of two integer numbers)

https://leetcode.com/problems/sum-of-two-integers/

## Title description

```
Calculate the sum of two integer numbers a and b without using the operators + and -.

Example 1:

Input: a = 1, b = 2
Output: 3
Example 2:

Input: a = -2, b = 3
Output: 1

```

## Pre-knowledge

-[Bit operation](https://github.com/azl397985856/leetcode/blob/master/thinkings/bit.md)

## Company

-Ali
-Tencent
-Baidu
-Byte

## Idea

Addition and subtraction cannot be used to find addition. We can only think from the perspective of arithmetic.

Since "XOR" is `the same bit is 0, different bit is 1`, we can think of XOR as a kind of addition and subtraction without carry.

![371.sum-of-two-integers-1](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlud9y5phj30eu0b8jro.jpg)

Since 'and`are`if all bits are 1, then bits are 1, otherwise bits are 0`, we can shift one bit to the left after the sum to indicate carry.

![371.sum-of-two-integers-2](https://tva1.sinaimg.cn/large/007S8ZIlly1ghludauj6aj30ev0f00t5.jpg)

Then we can solve the above two meta-calculations recursively. The end condition of recursion is that one of them is 0, and we return the other directly.

## Analysis of key points

-Bit operation
-XOR is an addition and subtraction method that does not carry
-After finding the sum, shift one digit to the left to indicate carry

## Code

Code support: JS, C++, Java, Python
Javascript Code:

```js
/*
 * @lc app=leetcode id=371 lang=javascript
 *
 * [371] Sum of Two Integers
 */
/**
 * @param {number} a
 * @param {number} b
 * @return {number}
 */
var getSum = function (a, b) {
	if (a === 0) return b;

	if (b === 0) return a;

	return getSum(a ^ b, (a & b) << 1);
};
```

C++ Code:

```c++
class Solution {
public:
int getSum(int a, int b) {
if(a==0) return b;
if(b==0) return a;

while(b! =0)
{
// Prevent AddressSanitizer from overflow protection processing of signed left shift
auto carry = ((unsigned int ) (a & b))<<1;
// Calculate the result without carry
a = a^b;
//Set the position where carry exists to 1
b =carry;
}
return a;
}
};
```

Java Code:

```java
class Solution {
public int getSum(int a, int b) {
if(a==0) return b;
if(b==0) return a;

while(b! =0)
{
int carry = a&b;
// Calculate the result without carry
a = a^b;
//Set the position where carry exists to 1
b =carry<<1;
}
return a;
}
}
```

Python Code:

```python
# python integer type is Unifying Long Integers, that is, infinite-length integer type.
# Simulate 32bit signed integer addition
class Solution:
def getSum(self, a: int, b: int) -> int:
a &= 0xFFFFFFFF
b &= 0xFFFFFFFF
while b:
carry = a & b
a ^= b
b = ((carry) << 1) & 0xFFFFFFFF
# print((a, b))
return a if a < 0x80000000 else ~(a^0xFFFFFFFF)
```

**Complexity analysis**

-Time complexity:$O(1)$
-Spatial complexity:$O(1)$

> Since the scale of the topic data will not change, the complexity analysis is actually meaningless.

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
