## Problem (455. Distribute biscuits)

https://leetcode.com/problems/assign-cookies/

## Title description

```
Suppose you are a great parent and want to give your children some cookies. However, each child can only give a maximum of one biscuit. For each child i, there is an appetite value gi, which is the minimum size of a biscuit that can satisfy the child's appetite; and each biscuit j has a size sj. If sj>=gi, we can assign this cookie j to child i, and this child will be satisfied. Your goal is to satisfy as many children as possible and output this maximum value.

note：

You can assume that the appetite value is positive.
A child can only have one biscuit at most.

Example 1:

Input: [1,2,3], [1,1]

Output: 1

explain:

You have three children and two small biscuits. The appetite values of the three children are: 1, 2, and 3.
Although you have two small biscuits, since their size is 1, you can only satisfy children with an appetite value of 1.
So you should output 1.

Example 2:

Input: [1,2], [1,2,3]

Output: 2

explain:

You have two children and three small biscuits, and the appetite value of the two children is 1,2.
The number and size of cookies you have are enough to satisfy all children.
So you should output 2.
```

## Pre-knowledge

-[Greedy Algorithm](https://github.com/azl397985856/leetcode/blob/master/thinkings/greedy.md)
-Double pointer

## Company

-Ali
-Tencent
-Byte

## Idea

This question can be solved by greed. Biscuits for a child should be as small as possible and can satisfy the child, and the big ones should be reserved to satisfy the child with a big appetite. Because children with small appetites are the easiest to satisfy, priority is given to meeting the needs of children with small appetites. Use cookies in the order from small to large to see if they can satisfy a certain child.

algorithm：

-Sort the demand factors g and s from small to large
-Use greedy thinking and cooperate with two pointers. Each cookie will only be tried once. If it succeeds, the next child will try it, and if it fails, the next cookie child will try it.

## Key points

-Sort first, then be greedy

## Code

Language support: JS

```js
/**
* @param {number[]} g
* @param {number[]} s
* @return {number}
*/
const findContentChildren = function (g, s) {
g = g. sort((a, b) => a - b);
s = s. sort((a, b) => a - b);
Let gi=0; // Default value
let sj=0; // Biscuit size
let res = 0;
while (gi < g. length && sj < s. length) {
// When Biscuit sj>=appetite gi, biscuit satisfies the appetite, updates the number of satisfied children and moves the pointer
if (s[sj] >= g[gi]) {
gi++;
sj++;
res++;
} else {
// When biscuit sj < appetite gi, the biscuit cannot satisfy the appetite and needs to be replaced with a larger one
sj++;
}
}
return res;
};
```

**_Complexity analysis_**

-Time complexity: Due to the use of sorting, the time complexity is O (NlogN)
-Spatial complexity: O(1)

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
