## Problem (575. Sub-candy)

https://leetcode.com/problems/distribute-candies/

## Title description

```
Given an array of even length, different numbers represent different types of candies, and each number represents a candy. You need to divide these candies equally between a younger brother and a younger sister. Return the number of types of candies that the sister can get the most.

Example 1:

Input: candies = [1,1,2,2,3,3]
Output: 3
Analysis: There are three types of candies in total, each with two types.
Optimal distribution plan: the younger sister gets [1,2,3], and the younger brother also gets [1,2,3]. This allows my sister to get the most types of candies.
Example 2 :

Input: candies = [1,1,2,3]
Output: 2
Analysis: The younger sister gets candy [2,3], and the younger brother gets candy [1,1]. The younger sister has two different candies, and the younger brother has only one. This makes the sister have the largest number of types of candies available.
note:

The length of the array is [2, 10,000], and it is determined to be even.
The size of the numbers in the array is in the range [-100,000, 100,000].

```

## Pre-knowledge

-[array](https://github.com/azl397985856/leetcode/blob/master/thinkings/basic-data-structure.md)

## Company

-Ali
-Byte

## Idea

Since the candies are even, we only need to make the same number of candies for two people.

Consider two situations:

![575.distribute-candies](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlucvt9rcj30kw09pmy6.jpg)

-If the types of candies are greater than n / 2 (the number of types of candies is n), the most types of candies that my sister can get should be`n /2` (because my sister only has n /2 candies).
-The number of types of candies is less than n /2. The types of candies that my sister can get can be the number of types of candies (there are so many types of candies in themselves).

Therefore, we found that the limiting factor for the types of candies that younger sisters can obtain is actually the number of types of candies.

## Analysis of key points

-This is a logical topic, so if the logic is analyzed clearly, the code is natural

## Code

-Language support: JS, Python

Javascript Code:

```js
/*
 * @lc app=leetcode id=575 lang=javascript
 *
 * [575] Distribute Candies
 */
/**
 * @param {number[]} candies
 * @return {number}
 */
var distributeCandies = function (candies) {
	const count = new Set(candies);
	return Math.min(count.size, candies.length >> 1);
};
```

Python Code:

```python
class Solution:
def distributeCandies(self, candies: List[int]) -> int:
return min(len(set(candies)), len(candies) >> 1)
```

**Complexity analysis**

-Time complexity:$O(N)$
-Spatial complexity:$O(N)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
