## Problem (874. Simulate walking robot)

https://leetcode.com/problems/walking-robot-simulation/submissions/

## Title description

```
The robot walks on an infinite grid, starting from the point (0, 0) and facing north. The robot can receive the following three types of commands：

-2: Turn left 90 degrees
-1: Turn right 90 degrees
1<=x<=9: Move x units of length forward
There are some grids on the grid that are regarded as obstacles.

The i-th obstacle is located at the grid point (obstacles[i][0], obstacles[i][1])

If the robot tries to walk above the obstacle, it will stay on the previous grid square of the obstacle, but can still continue the rest of the route.

Returns the square of the maximum euclidean distance from the origin to the robot.



Example 1：

Input: commands = [4, -1,3], obstacles = []
Output: 25
Explanation: The robot will arrive (3, 4)
Example 2：

Input: commands =[4, -1,4, -2,4], obstacles=[[2,4]]
Output: 65
Explanation: The robot will be trapped at (1, 4) before turning left and walking to (1, 8)


prompt：

0 <= commands. length <= 10000
0 <= obstacles. length <= 10000
-30000 <= obstacle[i][0] <= 30000
-30000 <= obstacle[i][1] <= 30000
The answer is guaranteed to be less than 2^31


```

## Pre-knowledge

- hashtable

## Company

-No

## Idea

The reason why this question is simple and difficult is because it has no skills. You only need to understand the title description, and then convert the title description into code.

The only thing to note is that if you use `linear lookup` when looking for obstacles, it will be very slow and will most likely time out.

> I actually tested it and it does time out

-One way is to use sorting and then binary lookup. If a comparison-based sorting algorithm is used, the bottleneck of this algorithm lies in the sorting itself, which is$O (NlogN)$.
-Another way is to use a collection, put obstacles into the collection, and then query when needed. The time complexity of the query is$O(1)$.

Here we use the second method.

Next, let's “translate” the topic.

-Since the robot can only go forward. Therefore, which direction the robot goes in, east, west, south, and north depends on its `orientation`.
-We use enumeration to represent the `orientation` of the current robot.
-There are only two ways to change the "orientation" of the topic, one is to turn left (-2) and the other is to turn right (-1).
-The title requires the robot to be 'the maximum distance from the origin during movement`, not the distance from the origin of the final position.

In order to make the code writing simple, I established a cartesian coordinate system. Use'the degree of angle between the orientation of the robot and the positive direction of the x-axis` as the enumeration value, and this degree is`0<=deg<360`. It is not difficult for us to know, in fact, this value is`0`, `90`,`180`,`270` Four values. Then when it is 0 degrees, we only need to keep x + 1, when it is 90 degrees, we keep y + 1, and so on.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1ghlu040owij31020r8gos.jpg)

## Analysis of key points

-Understand the meaning of the question, this question is easy to understand the wrong meaning of the question, and the solution is'the distance from the origin of the final position`
-Establish a coordinate system
-Space for time

## Code

Code support: Python3

Python3 Code:

```python
class Solution:
def robotSim(self, commands: List[int], obstacles: List[List[int]]) -> int:
pos = [0, 0]
deg = 90
ans = 0
obstaclesSet = set(map(tuple, obstacles))

for command in commands:
if command == -1:
deg = (deg + 270) % 360
elif command == -2:
deg = (deg + 90) % 360
else:
if deg == 0:
i = 0
while i < command and not (pos[0] + 1, pos[1]) in obstaclesSet:
pos[0] += 1
i += 1
if deg == 90:
i = 0
while i < command and not (pos[0], pos[1] + 1) in obstaclesSet:
pos[1] += 1
i += 1
if deg == 180:
i = 0
while i < command and not (pos[0] - 1, pos[1]) in obstaclesSet:
pos[0] -= 1
i += 1
if deg == 270:
i = 0
while i < command and not (pos[0], pos[1] - 1) in obstaclesSet:
pos[1] -= 1
i += 1
ans = max(ans, pos[0] ** 2 + pos[1] ** 2)
return ans
```

**Complexity analysis**

-Time complexity:$O(N*M)$, where N is the length of commands and M is the average value of the commands array.
-Spatial complexity:$O(obstacles)$

For more questions, please visit my LeetCode questions warehouse:https://github.com/azl397985856/leetcode . There are already 37K stars.

Pay attention to the official account, work hard to restore the problem-solving ideas in clear and straightforward language, and there are a large number of diagrams to teach you how to recognize routines and brush questions efficiently.

![](https://tva1.sinaimg.cn/large/007S8ZIlly1gfcuzagjalj30p00dwabs.jpg)
